//
//  v002RuttEtraPlugIn.m
//  v002RuttEtra
//
//  Created by vade on 9/23/08.
//  Copyright (c) 2008 vade/Bill Etra. All rights reserved.
//
//  Heightfield_gtplugin.h Created by George Toledo 2/15/10. Edits to v002 RuttEtra to fit my whims! Thanks @ Vade for publishing the source, and Bill Etra. Please donate to the Bill Etra fund.
//
//

/* It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering */
#import <OpenGL/CGLMacro.h>
#import <OpenGL/glu.h>

#import "Heightfield_gtPlugIn.h"

#define	kQCPlugIn_Name				@"Heightfield_gt"
#define	kQCPlugIn_Description		@"Heightfield_gt, Version 0.02. 2011, George Toledo, customization of v002 Rutt Etra. Please Donate to Bill Etra! Vade:For Bill. Emulates the Rutt/Etra raster based analog computer, video synthesizer and effects system. This software is donation ware. All procedes go towards helping Bill Etra and the further development of this plugin. If you would like to donate, please visit http://002.vade.info. Thank you. Original Licence - http://002.vade.info Copyright vade - Anton Marini, Bill Etra Creative Commons, Attribution - Non Commercial - Share Alike 3.0"

@implementation Heightfield_gtPlugIn

/*
Here you need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation
@dynamic inputFoo, outputBar;
*/

@dynamic inputImage;
@dynamic inputImageLuma;
//@dynamic inputImageNormal;
@dynamic inputDrawType;
@dynamic inputWireFrameWidth;
@dynamic inputDepthScale;
@dynamic inputResolutionX;
@dynamic inputResolutionY;
@dynamic inputAntialias;
@dynamic inputCalculateNormals;
@dynamic inputNormalCoeff;
@dynamic inputHQNormals;
@dynamic inputX; 
@dynamic inputY; 
@dynamic inputZ; 
@dynamic inputRotationX; 
@dynamic inputRotationY; 
@dynamic inputRotationZ;
@dynamic inputBlendMode;
@dynamic inputDepthMode;
@dynamic inputRepeatCount;
@dynamic inputStipplePattern;
@dynamic inputCulling;


+ (NSDictionary*) attributes
{
	/*
	Return a dictionary of attributes describing the plug-in (QCPlugInAttributeNameKey, QCPlugInAttributeDescriptionKey...).
	*/
	
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{
	/*
	Specify the optional attributes for property based ports (QCPortAttributeNameKey, QCPortAttributeDefaultValueKey...).
	*/
	
	if([key isEqualToString:@"inputImage"])
		return [NSDictionary dictionaryWithObject:@"Image" forKey:QCPortAttributeNameKey];

	if([key isEqualToString:@"inputImageLuma"])
		return [NSDictionary dictionaryWithObject:@"Depth Image" forKey:QCPortAttributeNameKey];

	if([key isEqualToString:@"inputDrawType"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Draw Mode",QCPortAttributeNameKey,
				[NSArray arrayWithObjects:@"Scanlines", @"Points", @"Square Mesh", @"Triangle Mesh", @"Image Plane", nil], QCPortAttributeMenuItemsKey,
				[NSNumber numberWithInt:0], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithInt:4], QCPortAttributeMaximumValueKey,
				nil];
	
	if([key isEqualToString:@"inputResolutionX"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Resolution X", QCPortAttributeNameKey,
				[NSNumber numberWithFloat:128.0], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithFloat:4.0], QCPortAttributeMinimumValueKey,
				nil];
	
	if([key isEqualToString:@"inputResolutionY"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Resolution Y", QCPortAttributeNameKey,
				[NSNumber numberWithFloat:128.0], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithFloat:4.0], QCPortAttributeMinimumValueKey,
				nil];
	
	if([key isEqualToString:@"inputRepeatCount"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Repeat Count", QCPortAttributeNameKey,
				[NSNumber numberWithFloat:1.0], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithFloat:0.0], QCPortAttributeMinimumValueKey,
				[NSNumber numberWithFloat:256.0], QCPortAttributeMaximumValueKey,
				nil];
	
	if([key isEqualToString:@"inputStipplePattern"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Stipple Pattern", QCPortAttributeNameKey,
				[NSNumber numberWithFloat:65535.0], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithFloat:0.0], QCPortAttributeMinimumValueKey,
				[NSNumber numberWithFloat:65535.0], QCPortAttributeMaximumValueKey,
				nil];
		

	if([key isEqualToString:@"inputDepthScale"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Z Extrude", QCPortAttributeNameKey,
				[NSNumber numberWithFloat:1.0], QCPortAttributeDefaultValueKey, 
				nil];
		
	if([key isEqualToString:@"inputWireFrameWidth"])
	{
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Element Size", QCPortAttributeNameKey,
				[NSNumber numberWithFloat:1.0], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithFloat:0.01], QCPortAttributeMinimumValueKey,
				[NSNumber numberWithFloat:100.0], QCPortAttributeMaximumValueKey,
				nil];	
	}
	
	if([key isEqualToString:@"inputAntialias"])
	{
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Element Antialiasing",QCPortAttributeNameKey,
				[NSNumber numberWithBool:TRUE], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithBool:FALSE], QCPortAttributeMinimumValueKey,
				nil];
	}
	
	if([key isEqualToString:@"inputCalculateNormals"])
	{
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Calculate Normals",QCPortAttributeNameKey,
				[NSNumber numberWithBool:FALSE], QCPortAttributeMinimumValueKey,
				nil];
	}
	
	if([key isEqualToString:@"inputNormalCoeff"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Normal Smoothness", QCPortAttributeNameKey,
				[NSNumber numberWithFloat:0.5], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithFloat:0.1], QCPortAttributeMinimumValueKey,
				[NSNumber numberWithFloat:5.0], QCPortAttributeMaximumValueKey,
				nil];
	
	if([key isEqualToString:@"inputHQNormals"])
	{
		return [NSDictionary dictionaryWithObjectsAndKeys:@"High Quality Normals",QCPortAttributeNameKey,
				[NSNumber numberWithBool:FALSE], QCPortAttributeMinimumValueKey,
				nil];
	}	
	
	if([key isEqualToString:@"inputX"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"X Position", QCPortAttributeNameKey, [NSNumber numberWithDouble:0.0], QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputY"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Y Position", QCPortAttributeNameKey, [NSNumber numberWithDouble:0.0], QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputZ"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Z Position", QCPortAttributeNameKey, [NSNumber numberWithDouble:0.0], QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputRotationX"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"X Rotation", QCPortAttributeNameKey, [NSNumber numberWithDouble:0.0], QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputRotationY"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Y Rotation", QCPortAttributeNameKey, [NSNumber numberWithDouble:0.0], QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputRotationZ"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Z Rotation", QCPortAttributeNameKey, [NSNumber numberWithDouble:0.0], QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputBlendMode"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Blending", QCPortAttributeNameKey,
                [NSArray arrayWithObjects:@"Replace", @"Over", @"Add", @"Alpha", @"GL_SRC_ALPHA_SATURATE, GL_ONE_MINUS_SRC_ALPHA", @"GL_SRC_ALPHA_SATURATE, GL_ONE", @"GL_ONE, GL_SRC_ALPHA_SATURATE", nil], QCPortAttributeMenuItemsKey,
                [NSNumber numberWithUnsignedInt:6], QCPortAttributeMaximumValueKey,
                [NSNumber numberWithUnsignedInt:3], QCPortAttributeDefaultValueKey,
                [NSNumber numberWithUnsignedInt:0], QCPortAttributeMinimumValueKey, nil];
    
	if([key isEqualToString:@"inputDepthMode"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Depth Testing", QCPortAttributeNameKey,
                [NSArray arrayWithObjects:@"None", @"Read/Write", @"Read-Only", nil], QCPortAttributeMenuItemsKey,
                [NSNumber numberWithUnsignedInt:2], QCPortAttributeMaximumValueKey,
                [NSNumber numberWithUnsignedInt:1], QCPortAttributeDefaultValueKey,
                [NSNumber numberWithUnsignedInt:0], QCPortAttributeMinimumValueKey, nil];
	
	if([key isEqualToString:@"inputCulling"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Face Culling", QCPortAttributeNameKey,
                [NSArray arrayWithObjects:@"None", @"Front", @"Back", nil], QCPortAttributeMenuItemsKey,
                [NSNumber numberWithUnsignedInt:2], QCPortAttributeMaximumValueKey,
                [NSNumber numberWithUnsignedInt:0], QCPortAttributeDefaultValueKey,
                [NSNumber numberWithUnsignedInt:0], QCPortAttributeMinimumValueKey, nil];
	
	return nil;
}

+ (NSArray*) sortedPropertyPortKeys
{
	return [NSArray arrayWithObjects:@"inputImage", @"inputImageLuma", @"inputDrawType", @"inputWireFrameWidth", @"inputAntialias", @"inputStipplePattern", @"inputRepeatCount", @"inputResolutionX", @"inputResolutionY", @"inputDepthScale", @"inputCalculateNormals", @"inputNormalCoeff", @"inputHQNormals", @"inputX", @"inputY", @"inputZ", @"inputRotationX", @"inputRotationY", @"inputRotationZ", @"inputBlendMode", @"inputDepthMode", @"inputCulling", nil];
	
}


+ (QCPlugInExecutionMode) executionMode
{
	/*
	Return the execution mode of the plug-in: kQCPlugInExecutionModeProvider, kQCPlugInExecutionModeProcessor, or kQCPlugInExecutionModeConsumer.
	*/
	
	return kQCPlugInExecutionModeConsumer;
}

+ (QCPlugInTimeMode) timeMode
{
	/*
	Return the time dependency mode of the plug-in: kQCPlugInTimeModeNone, kQCPlugInTimeModeIdle or kQCPlugInTimeModeTimeBase.
	*/
	
	return kQCPlugInTimeModeNone;
}

- (id) init
{
	if(self = [super init]) {
		/*
		Allocate any permanent resource required by the plug-in.
		*/
		kSizeX = 4;
		kSizeY = 4;
	}
	
	return self;
}

- (void) finalize
{
	/*
	Release any non garbage collected resources created in -init.
	*/
	
	[super finalize];
}

- (void) dealloc
{
	/*
	Release any resources created in -init.
	*/
	
	[super dealloc];
}

@end

@implementation Heightfield_gtPlugIn (Execution)

- (BOOL) startExecution:(id<QCPlugInContext>)context
{
	if(kSizeX < 4)
		kSizeX = 4;
	if(kSizeY < 4)
		kSizeY = 4;
	
	CGLContextObj cgl_ctx = [context CGLContextObj];
	if(cgl_ctx == NULL)
		return NO;
	
	CGLLockContext(cgl_ctx);
	
#pragma mark Check GL Extension support
	
	const GLubyte * extentionString;
	extentionString = glGetString (GL_EXTENSIONS); 
	
	supportsFloatTextures = gluCheckExtension((const GLubyte *) "GL_ARB_texture_float", extentionString);
//	if(supportsFloatTextures)
//		[context logMessage:@"Have ARB_texture_float support yay"];
//	else
//		[context logMessage:@"Do not have ARB_texture_float boo"];

	
	GLenum error;

	glPushAttrib(GL_ALL_ATTRIB_BITS);

	glGetIntegerv(GL_FRAMEBUFFER_BINDING_EXT, &previousFBO);
	glGetIntegerv(GL_READ_FRAMEBUFFER_BINDING_EXT, &previousReadFBO);
	glGetIntegerv(GL_DRAW_FRAMEBUFFER_BINDING_EXT, &previousDrawFBO);
	
	// store shader and unset it, we dont want it messing with things.
	glGetIntegerv(GL_CURRENT_PROGRAM, &previousShader);
	
	heightMapShader = [[gtShader alloc] initWithShadersInBundle:[NSBundle bundleForClass:[self class]] withName:@"gt.ImageToHeightMap" forContext:cgl_ctx];
	normalShader = [[gtShader alloc] initWithShadersInBundle:[NSBundle bundleForClass:[self class]] withName:@"gt.LumaToNormal" forContext:cgl_ctx];
	normalShaderHQ = [[gtShader alloc] initWithShadersInBundle:[NSBundle bundleForClass:[self class]] withName:@"gt.LumaToNormalHQ" forContext:cgl_ctx];
	
	if((heightMapShader == nil) || (normalShader == nil) || (normalShaderHQ == nil))
		return NO;
	
	glUseProgramObjectARB(NULL);

#pragma mark Create FBO Texture Attachments
	
	// Create FBO
	glGenFramebuffersEXT(1, &_frameBuffer);
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, _frameBuffer);
	
	if(supportsFloatTextures)
	{
		glGenTextures(1, &_textureAttachment0);	
		glBindTexture(GL_TEXTURE_RECTANGLE_ARB, _textureAttachment0);
		glTexImage2D(GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGBA16F_ARB, kSizeX, kSizeY, 0, GL_RGBA, GL_FLOAT, NULL);
		glBindTexture(GL_TEXTURE_RECTANGLE_ARB, 0);

		// bind
		glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_RECTANGLE_ARB, _textureAttachment0, 0);

	}	
	else
	{
		glGenRenderbuffersEXT(1, &_renderBuffer);
		glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, _renderBuffer);
		glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_RGBA32F_ARB, kSizeX, kSizeY);
		glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, 0);
		
		// bind
		glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_RENDERBUFFER_EXT, _renderBuffer);
	}

	error = glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT);
	
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
	
	if(error != GL_FRAMEBUFFER_COMPLETE_EXT)
	{
		
		glDeleteFramebuffersEXT(1, &_frameBuffer);
		if(supportsFloatTextures)
			glDeleteTextures(1, &_textureAttachment0);
		else
			glDeleteRenderbuffersEXT(1, &_renderBuffer);
	

		CGLUnlockContext(cgl_ctx);
		return NO;
	}	

#pragma mark Create VBOs
	glGenBuffers(1, &_vertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, _vertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, kSizeX * kSizeY * 4 * sizeof(GLfloat), NULL, GL_DYNAMIC_COPY);	// was * 4
	
	glGenBuffers(1, &_vertexBufferForNormals);
	glBindBuffer(GL_ARRAY_BUFFER, _vertexBufferForNormals);
	glBufferData(GL_ARRAY_BUFFER, kSizeX * kSizeY * 4 * sizeof(GLfloat), NULL, GL_DYNAMIC_COPY);

	glGenBuffers(1, &_vertexBufferForTexCoords);
	glBindBuffer(GL_ARRAY_BUFFER, _vertexBufferForTexCoords);
	glBufferData(GL_ARRAY_BUFFER, kSizeX * kSizeY * 4 * sizeof(GLfloat), NULL, GL_STATIC_COPY);

	glBindBuffer(GL_ARRAY_BUFFER, 0); // unbind.

#pragma mark Create DisplayList
	
	quadDL = glGenLists(1);
	
	glNewList(quadDL,GL_COMPILE);		
	glBegin(GL_QUADS);
	glTexCoord2f(1.0,1.0);
	glVertex3f(kSizeX, kSizeY, 0);
	glTexCoord2f(0.0, 1.0);
	glVertex3f(0, kSizeY, 0);
	glTexCoord2f(0.0, 0.0);
	glVertex3f(0, 0, 0);
	glTexCoord2f(1.0, 0.0);
	glVertex3f(kSizeX, 0, 0);
	glEnd();
	glEndList();
		
#pragma mark draw texcoords to VBO	

	// we draw into the texcoord buffer now because we only to generate this once.
	// Bind the FBO as the rendering destination
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, _frameBuffer);

	glDisable(GL_LIGHTING);
	glDisable(GL_BLEND);
	
	glViewport(0, 0, kSizeX, kSizeY);
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(0, kSizeX, 0, kSizeY, -1, 1);
	
	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
	glLoadIdentity();
	
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
		
	glDisable(GL_TEXTURE_RECTANGLE_EXT);
	
	// draw our quad with texcoords
	glBegin(GL_QUADS);
	glColor3f(1.0, 1.0, 0.0);
	glVertex3f(kSizeX, kSizeY, 0.0);
	glColor3f(0.0, 1.0, 0.0);
	glVertex3f(0.0, kSizeY, 0.0);
	glColor3f(0.0, 0.0, 0.0);
	glVertex3f(0.0, 0.0, 0.0);
	glColor3f(1.0, 0.0, 0.0);
	glVertex3f(kSizeX, 0.0, 0.0);
	glEnd();
		
	glBindBuffer(GL_PIXEL_PACK_BUFFER_ARB, _vertexBufferForTexCoords);	
	glReadPixels(0, 0, kSizeX, kSizeY, GL_RGBA, GL_FLOAT, NULL);	// was GL_RGBA
	glBindBuffer(GL_PIXEL_PACK_BUFFER_ARB, 0);	

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	
	glMatrixMode(GL_TEXTURE);
	glPopMatrix();
	
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	
	// restore state
	glPopAttrib();
	
	glUseProgram(previousShader);
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, previousFBO);
	glBindFramebufferEXT(GL_READ_FRAMEBUFFER_EXT, previousReadFBO);
	glBindFramebufferEXT(GL_DRAW_FRAMEBUFFER_EXT, previousDrawFBO);
	
	/* Check for OpenGL errors */
	if((error = glGetError()))
	{
		[context logMessage:@"OpenGL error %04X", error];
		glDeleteFramebuffersEXT(1, &_frameBuffer);
		
		if(supportsFloatTextures)
			glDeleteTextures(1, &_textureAttachment0);
		else
			glDeleteRenderbuffersEXT(1, &_renderBuffer);
		
		glDeleteBuffers(1, &_vertexBuffer);
		glDeleteBuffers(1, &_vertexBufferForNormals);
		glDeleteBuffers(1, &_vertexBufferForTexCoords);
		
		glDeleteLists(quadDL, 1);
		CGLUnlockContext(cgl_ctx);
		return NO;
	}
	
#pragma mark Indices generation for VBO
	// we are going to use 2 sets of indices here eventually. 
	// one for scanline drawing which requires one specific index ordering
	// and another for 'full raster' drawing, using the mesh of indices originally provided.
	
	// for scanlines
	scanLineIndices = malloc((kSizeX - 1) * (kSizeY -1) * 2 * sizeof(GLuint));
	// for mesh
	meshIndices = malloc((kSizeX - 1) * (kSizeY - 1) * 6 * sizeof(GLuint));
	
	if((scanLineIndices == NULL) || (meshIndices == NULL))
	{
		glDeleteFramebuffersEXT(1, &_frameBuffer);

		if(supportsFloatTextures)
			glDeleteTextures(1, &_textureAttachment0);
		else
			glDeleteRenderbuffersEXT(1, &_renderBuffer);
		
		glDeleteBuffers(1, &_vertexBuffer);
		glDeleteBuffers(1, &_vertexBufferForNormals);
		glDeleteBuffers(1, &_vertexBufferForTexCoords);
		
		glDeleteLists(quadDL, 1);
		
		CGLUnlockContext(cgl_ctx);

		return NO; // No kills the startExecution method for QC
	}
	else
	{
		// scanlines - vade
		int i = 0,x,y;

		for( y = 0; y < kSizeY - 1 ; y++)
		{
			for(x = 0; x < kSizeX - 1 ; x++)
			{
				// this little aparatus makes sure we do not draw a line segment between different rows of scanline.
				if (i % (kSizeX - 2) <= (kSizeX - 1))
				{ 
					scanLineIndices[i + 0] = x + y * kSizeX;
					scanLineIndices[i + 1] = x + y * kSizeX + 1;
				} 
				i+= 2;
			} 	  
		}
		
		// for mesh.
		i = 0;
		for(y = 0; y < kSizeY - 1; y++)
		{
			for(x = 0; x < kSizeX - 1 ; x++)
			{
				meshIndices[i + 0] = x + y * kSizeX;
				meshIndices[i + 1] = x + y * kSizeX + kSizeX;
				meshIndices[i + 2] = x + y * kSizeX + 1;
				meshIndices[i + 3] = x + y * kSizeX + 1;
				meshIndices[i + 4] = x + y * kSizeX + kSizeX;
				meshIndices[i + 5] = x + y * kSizeX + kSizeX + 1;
				i += 6;
			}
		}		
			
		CGLUnlockContext(cgl_ctx);
	}	
	return YES;
}

-(BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
	// change our resolution - stop and start to be clean about flushing VBO size.
	// this resets kSize cleanly globally, and pauses to rebuild the VBOs and indices
	// before restarting the rendering. Its very quick. We do this before doing anything else.
	if([self didValueForInputKeyChange:@"inputResolutionX"] || [self didValueForInputKeyChange:@"inputResolutionY"])
	{
		[self stopExecution:context];
		kSizeX = floorf(self.inputResolutionX);
		kSizeY = floorf(self.inputResolutionY);
		[self startExecution:context];
	}
	
	CGLContextObj					cgl_ctx = [context CGLContextObj];
	CGLLockContext(cgl_ctx);

	GLenum							error;
		
	id<QCPlugInInputImageSource>	image = self.inputImage;
	id<QCPlugInInputImageSource>	imageLuma = self.inputImageLuma; // added by vade
//	id<QCPlugInInputImageSource>	imageNormal = self.inputImageNormal; // added by vade
	GLfloat							wireFrameWidth = self.inputWireFrameWidth; // added by vade
	GLfloat							width = (image) ? [image imageBounds].size.width / [image imageBounds].size.height : 1.333;
	GLfloat							extrude = self.inputDepthScale;
//	GLint	oldFactor;
//	GLint	oldPattern;
	
	if(cgl_ctx == NULL)
		return NO;

	// cache all of our previous FBO targets (required for 10.6)
	glGetIntegerv(GL_FRAMEBUFFER_BINDING_EXT, &previousFBO);
	glGetIntegerv(GL_READ_FRAMEBUFFER_BINDING_EXT, &previousReadFBO);
	glGetIntegerv(GL_DRAW_FRAMEBUFFER_BINDING_EXT, &previousDrawFBO);
	glGetIntegerv(GL_LINE_STIPPLE_REPEAT, &oldFactor);
	glGetIntegerv(GL_LINE_STIPPLE_PATTERN, &oldPattern);
	
	// store shader and unset it, we dont want it messing with things.
	glGetIntegerv(GL_CURRENT_PROGRAM, &previousShader);
	glUseProgramObjectARB(NULL);
	
	// save state
	glPushAttrib(GL_ALL_ATTRIB_BITS);

#pragma mark Render vertex VBO
	
	// Bind the FBO as the rendering destination
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, _frameBuffer);

	glViewport(0, 0, kSizeX, kSizeY);
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(0, kSizeX, 0, kSizeY, -1, 1);
	
	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
	glLoadIdentity();

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	
	/* Draw the texture in its native colorspace */
	if(imageLuma && [imageLuma lockTextureRepresentationWithColorSpace:[imageLuma imageColorSpace] forBounds:[imageLuma imageBounds]])
	{
		[imageLuma bindTextureRepresentationToCGLContext:cgl_ctx textureUnit:GL_TEXTURE0 normalizeCoordinates:YES];

		glTexParameterf([imageLuma textureTarget], GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameterf([imageLuma textureTarget], GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glDisable(GL_LIGHTING);
		glDisable(GL_BLEND);
		//glDisable(GL_FOG);
		
		glUseProgramObjectARB([heightMapShader programObject]);
		glUniform1iARB([heightMapShader getUniformLocation:"tex0"], 0); // load tex0 sampler to texture unit 0 
		glUniform2fARB([heightMapShader getUniformLocation:"imageSize"], [imageLuma imageBounds].size.width,[imageLuma imageBounds].size.height); 
		
		// render our quad from our display list
		glCallList(quadDL);

		glUseProgramObjectARB(NULL);

		glPopAttrib();
		
		[imageLuma unbindTextureRepresentationFromCGLContext:cgl_ctx textureUnit:GL_TEXTURE0];
		[imageLuma unlockTextureRepresentation];
	}
	else
	{
		glClearColor(0.0, 0.0, 0.0, 0.0);
		glClear(GL_COLOR_BUFFER_BIT);
	}
	
	/* Copy the rendered pixels into the VBO */
	glBindBuffer(GL_PIXEL_PACK_BUFFER_ARB, _vertexBuffer);	

	// this is the slowest operation of the lot.
	glReadPixels(0, 0, kSizeX, kSizeY, GL_RGBA, GL_FLOAT, NULL);	// was GL_RGBA
	
#pragma mark Render Normals VBO
	
	// use the same FBO, render the same quad
	if(self.inputCalculateNormals)
	{
		// unbind vertex VBO
		glBindBuffer(GL_PIXEL_PACK_BUFFER_ARB, 0);

		/* Draw the texture in its native colorspace */
		if(imageLuma && [imageLuma lockTextureRepresentationWithColorSpace:[imageLuma imageColorSpace] forBounds:[imageLuma imageBounds]])
		{
			[imageLuma bindTextureRepresentationToCGLContext:cgl_ctx textureUnit:GL_TEXTURE0 normalizeCoordinates:YES];
			
			glTexParameterf([imageLuma textureTarget], GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			glTexParameterf([imageLuma textureTarget], GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			
			glPushAttrib(GL_ALL_ATTRIB_BITS);
			
			glDisable(GL_LIGHTING);
			glDisable(GL_BLEND);
			//glDisable(GL_FOG); //TODO: what the fuck is the Fog macro patch doing? Ugh.
			
			if(self.inputHQNormals)
			{
				glUseProgramObjectARB([normalShaderHQ programObject]);
				glUniform1iARB([normalShaderHQ getUniformLocation:"tex0"], 0); // load tex0 sampler to texture unit 0 
				glUniform1fARB([normalShaderHQ getUniformLocation:"coef"], self.inputNormalCoeff); 
			}
			else
			{	
				glUseProgramObjectARB([normalShader programObject]);
				glUniform1iARB([normalShader getUniformLocation:"tex0"], 0); // load tex0 sampler to texture unit 0 
				glUniform1fARB([normalShader getUniformLocation:"coef"], self.inputNormalCoeff);  
			}
			
			// render our quad from our display list
			glCallList(quadDL);
			
			glUseProgramObjectARB(NULL);
			
			glPopAttrib();
			
			[imageLuma unbindTextureRepresentationFromCGLContext:cgl_ctx textureUnit:GL_TEXTURE0];
			[imageLuma unlockTextureRepresentation];
		}
		else
		{
			glClearColor(0.0, 0.0, 0.0, 0.0);
			glClear(GL_COLOR_BUFFER_BIT);
		}
		
		/* Copy the rendered pixels into the VBO */
		glBindBuffer(GL_PIXEL_PACK_BUFFER_ARB, _vertexBufferForNormals);	
		
		// this is the slowest operation of the lot.
		glReadPixels(0, 0, kSizeX, kSizeY, GL_RGBA, GL_FLOAT, NULL);
	}	

#pragma mark End VBO buffer generation stage / start drawing to final context
	
	glBindBuffer(GL_PIXEL_PACK_BUFFER_ARB, 0);
	
	/* Unbind the FBO and restore previous rendering destination */
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glMatrixMode(GL_TEXTURE);
	glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

	// restore state
	glPopAttrib();
	
	// restore FBO target if any...
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, previousFBO);
	glBindFramebufferEXT(GL_READ_FRAMEBUFFER_EXT, previousReadFBO);
	glBindFramebufferEXT(GL_DRAW_FRAMEBUFFER_EXT, previousDrawFBO);

	// restore previous shader so it is in use.
	glUseProgram(previousShader);
	
	// now we render to the normal rendering destination
	
	// save state... 
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	/* Setup OpenGL state */
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	

	glTranslatef(self.inputX, self.inputY, self.inputZ);
	// Rotate the matrix
    glRotatef(self.inputRotationX, 1.0, 0.0, 0.0);
	glRotatef(self.inputRotationY, 0.0, 1.0, 0.0);
	glRotatef(self.inputRotationZ, 0.0, 0.0, 1.0);
	// aspect ratio
	glRotatef(90.0, 1.0, 0.0, 0.0);
	glTranslatef(- (width * 0.5), -0.5, -0.5);
	glScalef(width , extrude , 1.0);
	
	

	
	/* Draw the VBO */
		
	if(image && [image lockTextureRepresentationWithColorSpace:[image imageColorSpace] forBounds:[image imageBounds]])
	{	
		[image bindTextureRepresentationToCGLContext:cgl_ctx textureUnit:GL_TEXTURE0 normalizeCoordinates:YES];
	}
//		// generate texture coords - this is the old and dumb way
//		glEnable(GL_TEXTURE_GEN_S);
//		glEnable(GL_TEXTURE_GEN_T);
//
//		float s_plane[] = { 1, 0, 0, 0};
//		float t_plane[] = { 0, 0, 1, 0}; // we use the z plane here, but map it to y, since we are extruding on Z, not Y
//		glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
//		glTexGenfv(GL_S, GL_OBJECT_PLANE, s_plane);
//		glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
//		glTexGenfv(GL_T, GL_OBJECT_PLANE, t_plane);
		
		// draw vertex array.
		glEnableClientState(GL_VERTEX_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, _vertexBuffer);
		glVertexPointer(4, GL_FLOAT, 0, NULL);
					
		// normal data for lighting
		if(self.inputCalculateNormals)
		{
			glEnableClientState(GL_NORMAL_ARRAY);
			glBindBuffer(GL_ARRAY_BUFFER, _vertexBufferForNormals);
			glNormalPointer(GL_FLOAT, sizeof(GLfloat)*4, NULL);
			//glEnable(GL_RESCALE_NORMAL);
		}
		
		// static texcoord data
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, _vertexBufferForTexCoords);
		glTexCoordPointer(2, GL_FLOAT, sizeof(GLfloat)*4, NULL);
	
	glEnable(GL_LINE_STIPPLE);
	glLineStipple(self.inputRepeatCount, self.inputStipplePattern);
	
	
		if(self.inputBlendMode == 0)
			glDisable(GL_BLEND);
		else if(self.inputBlendMode == 1)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
		}
		else if(self.inputBlendMode == 2)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_ONE, GL_ONE);
		}
		else if(self.inputBlendMode == 3)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		}
		else if(self.inputBlendMode == 4)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA_SATURATE, GL_ONE_MINUS_SRC_ALPHA);
		}
		else if(self.inputBlendMode == 5)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA_SATURATE, GL_ONE);
		}
		else if(self.inputBlendMode == 6)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_ONE, GL_SRC_ALPHA_SATURATE);
		}
	
	
		if(self.inputDepthMode == 0)
			glDisable(GL_DEPTH_TEST);
		else if(self.inputDepthMode == 1)
		{
			glEnable(GL_DEPTH_TEST);
			glDepthFunc(GL_LEQUAL);
			glDepthMask(GL_TRUE);
		}
		else
		{
			glEnable(GL_DEPTH_TEST);
			glDepthMask(GL_FALSE);
		}  
	
		if(self.inputCulling == 0)
			glDisable(GL_CULL_FACE);
		else if(self.inputCulling == 1)
		{
			glEnable(GL_CULL_FACE);
			glCullFace(GL_BACK);
		}
		else
		{				
			glEnable(GL_CULL_FACE);
			glCullFace(GL_FRONT);
		}  
	
		
		if(self.inputAntialias)				
		{
			glEnable(GL_LINE_SMOOTH);
			glEnable(GL_POINT_SMOOTH);
		}
		else
		{
			glDisable(GL_LINE_SMOOTH);	
			glDisable(GL_POINT_SMOOTH);
		}
		
		switch (self.inputDrawType)
		{
			case 0: // scanlines
			{	
				
				// additive blending
				//glEnable(GL_BLEND);
				//glBlendFunc(GL_SRC_ALPHA, GL_ONE);
				
				glLineWidth(wireFrameWidth);
				glDrawElements(GL_LINES, (kSizeX -1) * (kSizeY -1) * 2, GL_UNSIGNED_INT, scanLineIndices);
				break;
			}	
			case 1: // points
			{	
				
				// additive blending
				//glEnable(GL_BLEND);
				//glBlendFunc(GL_SRC_ALPHA, GL_ONE);
				
				glPointSize(wireFrameWidth);
				glDrawElements(GL_POINTS, (kSizeX -1) * (kSizeY -1) * 2, GL_UNSIGNED_INT, scanLineIndices);			
				break;
			}
			case 2: // square mesh
			{
				
				// additive blending
				//glEnable(GL_BLEND);
				//glBlendFunc(GL_SRC_ALPHA, GL_ONE);
				
				glLineWidth(wireFrameWidth);
				glDrawElements(GL_LINES, (kSizeX -1) * (kSizeY -1) * 6, GL_UNSIGNED_INT, meshIndices);
				break;
			}	
			case 3: // triangle mesh
			{
				
				// additive blending
				//glEnable(GL_BLEND);
				//glBlendFunc(GL_SRC_ALPHA, GL_ONE);
				
				glLineWidth(wireFrameWidth);
				glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
				glDrawElements(GL_TRIANGLES, (kSizeX -1) * (kSizeY -1) * 6, GL_UNSIGNED_INT, meshIndices);
				break;
			}	
			case 4: // solid plane
			{	
				
				// Over blending
				//glEnable(GL_BLEND);
				//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
				
				glDrawElements(GL_TRIANGLES, (kSizeX -1) * (kSizeY -1) * 6, GL_UNSIGNED_INT, meshIndices);
				break;
			}
			
			default:
				break;
		}
	
		
		
		glBindBuffer(GL_ARRAY_BUFFER, 0);	

		// disable using the array
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		glDisableClientState(GL_NORMAL_ARRAY);
		glDisableClientState(GL_VERTEX_ARRAY);
		
		// disable added stuff // old texture coord generation.
//		glDisable(GL_TEXTURE_GEN_S);
//		glDisable(GL_TEXTURE_GEN_T);
	
		if(image)
		{
			// unbind texture
			[image unbindTextureRepresentationFromCGLContext:cgl_ctx textureUnit:GL_TEXTURE0 ];
			[image unlockTextureRepresentation];
		}
	
		
	// reset MODELVIEW MATRIX
	//glScalef(1.0, 1.0, 1.0); // restore scalef
	glDisable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LINE_SMOOTH);	
	glDisable(GL_POINT_SMOOTH);
	glDisable(GL_LINE_STIPPLE);
	glDisable(GL_CULL_FACE);
	glLineStipple(oldFactor, oldPattern);
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	
	// restore attributes
	glPopAttrib();	

	/* Check for OpenGL errors */
	    if((error = glGetError()))
		NSLog(@"OpenGL error %04X", error);

		CGLUnlockContext(cgl_ctx);
	
	return (error ? NO : YES);
}

- (void) stopExecution:(id<QCPlugInContext>)context
{
	CGLContextObj cgl_ctx = [context CGLContextObj];
	CGLLockContext(cgl_ctx);	
	
	/* Destroy OpenGL resources */
	glDeleteFramebuffersEXT(1, &_frameBuffer);

	if(supportsFloatTextures)
		glDeleteTextures(1, &_textureAttachment0);
	else
		glDeleteRenderbuffersEXT(1, &_renderBuffer);
	
	glDeleteBuffers(1, &_vertexBuffer);
	glDeleteBuffers(1, &_vertexBufferForNormals);
	glDeleteBuffers(1, &_vertexBufferForTexCoords);
	
	glDeleteLists(quadDL, 1);
	CGLUnlockContext(cgl_ctx);	

	/* Destroy index buffers */
	free(scanLineIndices);
	free(meshIndices);
}
@end
